// Copyright 2024-2025 XMOS LIMITED.
// This Software is subject to the terms of the XMOS Public Licence: Version 1.
#pragma once

#include "bump_allocator.h"
#include "dsp/drc.h"
#include "compressor_sidechain_config.h" // Autogenerated

typedef struct
{
    compressor_t comp;
    int n_inputs;
    int n_outputs;
    int frame_size;
}compressor_sidechain_state_t;

#define COMPRESSOR_SIDECHAIN_STAGE_REQUIRED_MEMORY (0)

void compressor_sidechain_init(module_instance_t* instance, adsp_bump_allocator_t* allocator, uint8_t id, int n_inputs, int n_outputs, int frame_size);

void compressor_sidechain_process(int32_t **input, int32_t **output, void *app_data_state);

void compressor_sidechain_control(void *state, module_control_t *control);
